image: elixir:1.7

stages:
  - setup
  - compile
  - test
  - build
  - publish
  - deploy

before_script:
  - make init

get-dependencies:
  stage: setup
  script:
    - make deps
  artifacts:
    expire_in: 3 days
    paths:
      - deps
      - mix.lock

compile-for-test:
  stage: compile
  dependencies:
    - get-dependencies
  variables:
    MIX_ENV: test
  script:
    - make compile
  artifacts:
    expire_in: 3 days
    untracked: true

compile-for-production:
  stage: compile
  dependencies:
    - get-dependencies
  variables:
    MIX_ENV: prod
  script:
    - make compile
  artifacts:
    expire_in: 3 days
    untracked: true

lint:
  stage: test
  dependencies:
    - get-dependencies
    - compile-for-test
  variables:
    MIX_ENV: test
  script:
    - make lint

tests:
  stage: test
  services:
    - name: mongo:3.6
      alias: mongodb
  dependencies:
    - get-dependencies
    - compile-for-test
  variables:
    MIX_ENV: test
  coverage: '/\[TOTAL\]\s+(\d+\.\d+)%/'
  artifacts:
    expire_in: 3 days
    untracked: true
  script:
    - sleep 5 # waiting for mongoDB to accept requests
    - make test

static-analysis:
  stage: test
  dependencies:
    - get-dependencies
    - compile-for-test
  variables:
    MIX_ENV: test
    HOME: ${CI_PROJECT_DIR}
  artifacts:
    expire_in: 14 days
    paths:
      - ${CI_PROJECT_DIR}/.cache/dialyzer
  script:
    - make analyse
